<?php

// This include file is used to monitor site access and bar access to ripping.
// As coded, it should be included in the begin.php file of a TNG revision 6.0.0/5.1.4 installation
// using the line  -> include($cms[tngpath] . "check_access.php");
// immediately after the include("config.php"); 
// 
// Customizations:
//   - check the user configurable values below
//   - check the robot index exclusions below
//
// Revision 1.17, Sun Jan 27, 2008
// Brian McFadyen

// The following parameters are user configurable.  The defaults worked for me.


	$access_table = "site_access";   // A new TNG table that will be automatically created
	$fastest_access = 1.0;       // seconds between accesses to be considered fast. 0.5 is faster than most indexers
	$rip_ban = 6;           // number of fast clicks without a reset before banned
	$rip_warn = 3;          // number of fast clicks without a reset before a warning
	$rip_reset = 4;         // fast click reset time in seconds
	$rip_ban_time = 60;     // ban time in seconds
	$max_recent_hits = 30;	// number of consecutive hits before a captcha challenge is initiated (set to 0 to disable)
	$reset_recent_hits = 3600 * 8;	// # of seconds before a reset of the rip_challenge hit tracker (default 8 hours)
	$recent_hits = 0;


	 $link = @mysql_connect($database_host, $database_username, $database_password);
   if( !($link && mysql_select_db($database_name))) exit;

  $therows = 0;	
   $remip = getenv( "REMOTE_ADDR" );
   if( !$remip ) $remip = $_SERVER['REMOTE_ADDR'];
   $remhost = getenv( "REMOTE_HOST" );
   if( !$remhost ) $remhost = $_SERVER['REMOTE_HOST'];
   if( !$remhost ) $remhost = @gethostbyaddr( $remip );
   if( !$remhost ) $remhost = $remip;
	
	$not_indexer = true;

// Check each friendly indexer and group their IPs and accesses into one lump each
// Most indexers use multiple servers/IPs, so this helps to total them into their own range

	if (strpos($remhost,"google") !== false) {
			$remhost = "googlebot.com";
			$remip = "66.249.6x.x";
	} elseif (strpos($remip,"66.249.6") !== false){
			$remhost = "googlebot.com";
			$remip = "66.249.6x.x";
	} elseif (strpos($remhost,"inktomi") !== false){
			$remhost = "inktomisearch.com";
			$remip = "74.6.x.x";
	} elseif (strpos($remip,"74.6.") !== false){
			$remhost = "inktomisearch.com";
			$remip = "74.6.x.x";
	} elseif (strpos($remip,"66.231.189") !== false){
			$remhost = "gigablast.com";
			$remip = "66.231.189.x";
	} elseif (strpos($remhost,"search.live.com") !== false){
			$remhost = "search.live.com";
			$remip = "65.x.x.x";
	} elseif (strpos($remip,"65.55.212.") !== false){
			$remhost = "search.live.com";
			$remip = "65.x.x.x";
	} elseif (strpos($remip,"72.30.") !== false){
			$remhost = "inktomisearch.com";
			$remip = "74.6.x.x";
	}
	// Determine the referer site and clean up the text so it's not so messy
	
	$referer = getenv('HTTP_REFERER'); 
	$referer = ereg_replace("&tree=.*","",$referer);
	$referer = str_replace("&&","&",$referer);
	$referer = str_replace("&amp;$","",$referer);
	$referer = str_replace($tngdomain,"..",$referer);
	
	// Create a time index of 'now' for comparison later
	list($usec, $sec) = explode(" ", microtime());
  $utime = ((float)$usec + (float)$sec);

session_start();
  
// Check the existing user database table and do the automatic upgrades from previous versions, or create if required

  if(!mysql_query("SELECT recent_hits FROM " . $access_table . " LIMIT 1")){  // added at rev 1.17
  	if(!mysql_query("SELECT hit_note2 FROM " . $access_table . " LIMIT 1")){  // added at rev 1.8
  	  if(!mysql_query("SELECT hit_note_request FROM " . $access_table . " LIMIT 1")){  // added at rev 1.7
  			if(!mysql_query("SELECT host_ip FROM " . $access_table . " LIMIT 1")){ // new installation
  				echo "Attempting to Create Rip Prevention Table<br />";
  				$dbw_query = "CREATE TABLE IF NOT EXISTS $access_table(host_ip VARCHAR(32) NOT NULL, PRIMARY KEY(host_ip), host_name VARCHAR(64), hit_time DOUBLE, hit_count INT DEFAULT 0, ripping INT DEFAULT 0, waiting INT DEFAULT 0,  total_rip INT DEFAULT 0, hit_warn INT DEFAULT 0, hit_ban INT DEFAULT 0, hit_refer VARCHAR(200), hit_note_request INT DEFAULT 0, hit_note_response INT DEFAULT 0, hit_note_time DOUBLE, hit_note VARCHAR(250), hit_note2 VARCHAR(250), hit_note3 VARCHAR(250), hit_note4 VARCHAR(250), recent_hits INT DEFAULT 0)";
				}else{
					echo "Attempting to upgrade Rip Prevention table from version 1.6<br />";
  				$dbw_query = "ALTER TABLE $access_table ADD hit_note_request INT DEFAULT 0, ADD hit_note_response INT DEFAULT 0, ADD hit_note_time DOUBLE, ADD hit_note VARCHAR(250), ADD hit_note2 VARCHAR(250), ADD hit_note3 VARCHAR(250), ADD hit_note4 VARCHAR(250), recent_hits INT DEFAULT 0";
  			}
  		}else{
  			echo "Attempting to upgrade Rip Prevention table from version 1.7<br />"; 
  			$dbw_query = "ALTER TABLE $access_table ADD hit_note2 VARCHAR(250), ADD hit_note3 VARCHAR(250), ADD hit_note4 VARCHAR(250), recent_hits INT DEFAULT 0";
  		}
  	}else{
  		echo "Attempting to upgrade Rip Prevention table from version 1.16<br />";
	  	$dbw_query = "ALTER TABLE $access_table ADD recent_hits INT DEFAULT 0";
	  }
	  $therows = mysql_query($dbw_query);
  }			
  			
  $dbw_query = "SELECT * FROM " . $access_table . " WHERE host_ip=\"" . $remip ."\"";
  
  // is this a return visitor?
  if(mysql_num_rows($results = mysql_query($dbw_query)) > 0 ) {
  	  $row = mysql_fetch_array($results);
			$ripping = $row[ripping];
			$total = $row[total_rip];
			$waiting = $row[waiting];
			$hitwarn = $row[hit_warn];
			$hitban = $row[hit_ban];
			$noterequest = $row[hit_note_request];
			$recent_hits = $row[recent_hits]+1;
			// if we are just returning from a rip challenge screen, check the user response
			if(isset($HTTP_POST_VARS[rip_challenge_next])){
					@include("rip_challenge.php");
					// if the response was correct, we continue to here and reset the count
					// a failed response gets trapped in the challenge screen and never returns
					$recent_hits = 0;
				}
			if(($utime-$row[hit_time]) > $reset_recent_hits) $recent_hits = 0;
		
			// reset the ban timer if time is up
			if(($utime-$row[hit_time]) > $rip_ban_time){
				$waiting = 0;
			}
			// reset the ripping timer if the time is up
			if(($utime-$row[hit_time]) > $rip_reset){
				$ripping = 0;
			}
			// is this access too fast since last visit?
			if(($utime-$row[hit_time]) < $fastest_access){
				$ripping += 1;
				$total += 1;
			}
			// if these accesses are too many, then set a ban waiting time
			if($ripping > $rip_ban) {
				$waiting = 1;
				$hitban += 1;
				$ripping = 0;
			}
			if($row[hit_ban] == -1) {
				$waiting = 1;
				$hitban = -1;
			}
			// if these accesses are too fast, then issue a warning
			if($ripping > $rip_warn) {
				$hitwarn += 1;
			}
			// don't ban valid indexers
			// -------------------------------------
			// This section may be customized for your personal preferences
			// Delete or comment out the indexers that you think are friendly
			// -------------------------------------
			$ok_user = $_SESSION['allow_admin_db'];
			$logged_in = $_SESSION['currentuser'];
			
			if (strpos($remhost,"google") !== false || 
				strpos($remhost,"msnbot") !== false || 
				strpos($remhost,"inktomi") !== false || 
				strpos($remhost,"search.live") !== false || 
				strpos($remhost,"werelate") !== false || 
				strpos($remhost,"Panscient") !== false || 
				strpos($remhost,"gigablast") !== false ||
				$logged_in != "" ||
				$ok_user == 1 ){
					$waiting = 0;
					$ripping = 0;
					$recent_hits = 0;
			}
	    $refr = ", hit_refer=\"$referer\" ";
	    if(strlen($referer) < 6)
	    {
				$refr = " ";
	    }
	    $dbw_query = "UPDATE " . $access_table . " SET host_name=\"$remhost\",hit_count=" . ($row[hit_count]+1) . ",hit_time=" . $utime . ",ripping=" . $ripping . ",total_rip=" . $total . ",hit_warn=" . $hitwarn . ",hit_ban=" . $hitban . ", waiting=" . $waiting . ", recent_hits=" . $recent_hits . "$refr WHERE host_ip=\"$remip\"";
	    $results = mysql_query($dbw_query);
	    
	    // if visitor has been banned, display the banned page and exit
			if($waiting){
				@include("rip_ban.html");
	    	exit;
	    }
	    // if visitor is to be warned, display the warning and exit
			if($ripping > $rip_warn) {
				@include("rip_warning.html");
				exit;
			}
			// if there is an administrative note to display, then add it to the page before continuing
			if($noterequest != 0){
				$noterequest -= 1;
				global $mod_note;
				$mod_note = "<style type=\"text/css\">
.notes {
	font-size: 100%;
	color: #006600;
	background: #FFFF88;
	width: 500
	 }
</style>
<table cellpadding=5 border=1 class=\"notes\">
				<tr><td><b>Personal Note from Site Administrator:<br>TO:</b>&nbsp;&nbsp;$row[host_name]<br>This note will appear $row[hit_note_request] more time(s)<br><hr>$row[hit_note]$row[hit_note1]$row[hit_note2]$row[hit_note3]<br></td></tr></table><br>";

				$db_query="UPDATE $access_table set hit_note_request=\"$noterequest\" where host_name=\"$remhost\"";
				$result = mysql_query($db_query);
			}
			// if the visitor has exceeded his recent hit quota, then send them to the automated response challenge
			if(($max_recent_hits != 0) && $recent_hits > $max_recent_hits){
					@include("rip_challenge.php");
					// the rip challenge should never return here, but exit just in case
					exit;
			}
	}	else {
		// new visitor, add them to the database
    $dbw_query= "INSERT " . $access_table . " SET host_ip=\"$remip\", host_name=\"$remhost\", hit_time=$utime, hit_count=1, hit_refer=\"$referer\"";
    $results = mysql_query($dbw_query);
	}
?>
